/* Copyright (c) 2012  Georg-Johann Lay
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in
     the documentation and/or other materials provided with the
     distribution.
   * Neither the name of the copyright holders nor the names of
     contributors may be used to endorse or promote products derived
     from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. */

/* $Id$	*/

#if	!defined (__DOXYGEN__)
#if	!defined (__AVR_TINY)

#include "asmdef.h"

/* char *ultoa (unsigned long val, char *s, int radix)	*/

#define val_lo	r22
#define val_hi	r23
#define val_hlo	r24
#define val_hhi	r25
#define str_lo	r20
#define rdx_lo	r18
#define rdx_hi	r19	/* one is also used as bits counter	*/

#define rzero	r1
#define digit	r26
#define rsign	r27

;; Clobbers: T, 18..23, X, Z

ENTRY	ultoa
	clr	rsign

ENTRY	__ultoa_common
	X_movw	ZL, str_lo

  ; Check radix
	cpi	rdx_lo, lo8(37)
	cpc	rdx_hi, rzero
	brsh	7f
	cpi	rdx_lo, 2
	brlo	7f

1:	; Saves one iteration of the digit-loop:
	; If val < radix we can use the low byte of val as digit
	mov	digit, val_lo
	cp	val_lo, rdx_lo
	cpc	val_hi, rzero
	cpc	val_hlo, rzero
	cpc	val_hhi, rzero
	;; T=1:  Reminder to stop the digit-loop
	rol	rdx_hi
	bst	rdx_hi, 0
	brts	4f

	;; If val >= radix, then pop one digit from val
	clr	digit

2:	;; Vanilla 32:8 quotient and remainder to pop the digit
	;; digit <- val % radix
	;; val   <- val / radix
	lsl	val_lo
	rol	val_hi
	rol	val_hlo
	rol	val_hhi
	rol	digit
	cp	digit, rdx_lo
	brlo	3f
	sub	digit, rdx_lo
	;; val |= 1
	inc	val_lo
3:	;; Loop the 32 bits
	subi	rdx_hi, 8		; 256 / 8 == 32 loops
	brne	2b

4:	;; Convert the digit to ASCII...
	subi	digit, -'0'
	cpi	digit, '9'+1
	brlo	5f
	subi	digit, '0'-'a'+10
5:	;; ... and store it to the reversed string
	st	Z+, digit

	;; Popped all digits?
	brtc    1b

	;; Yes:  Store the sign (if any)
	cpse	rsign, rzero
	st	Z+, rsign

	;; Terminate the string with '\0'
7:	st	Z+, rzero

	;; Reverse the string and return the original string pointer
	X_movw	r24, str_lo
	XJMP	_U(strrev)

ENDFUNC

#endif	/* !__AVR_TINY__ */
#endif	/* !__DOXYGEN__ */
